(* ::Package:: *)

newEntry="kaylesDef";
kaylesDef=
	"Kayles"->
	<|
		"Name"->{"Kayles"},
		"SuperClass"->GameEntity["Combinatorial game"],

		"runTypeDefinition":>
			Class[kaylesGame ->combinatorialGame,
				"$Properties"->{
				
				"legalStateQ",
				"endStateQWinner",
				"possibleMoves",
				"nextState",
				"drawState"
			},
			
			"$Init"[self_,initialPins_]:>
				(
				self["initialState"]=<|
					"pins"->ReverseSort[initialPins],
					"toMove"->1
				|>;
				self["currentState"]=self["initialState"];
				),
			
			"initialState"-><||>,
			
			"legalStateQ"[self_]:>Function[state,Module[{},
				If[!AssociationQ[state],
					Print["Game state is not an association"];
				];
				
				If[Keys[state]!={"pins","toMove"},
					Print["Game state has incorrect keys"];
				];
				
				If[!MemberQ[{1,2},state["toMove"]],
					Print["Player ",state["toMove"], " does not exist"];
				];
				
				If[!ListQ[state["pins"]],
					Print["Pins is not a list."];
				];
			]],
	
			"endStateQWinner"[self_,state_]:>Module[{},
				If[state["pins"]=={},
				<|"endState"->True,"winner"->3-state["toMove"]|>,
				<|"endState"->False,"winner"->Null|>
				]
			],
			
			"possibleMoves"[self_,state_]:>Module[
			{g},
			g=self["endStateQ"[state]];
			If[
				g,
				{},
				Select[Flatten[MapIndexed[Function[{x,y},Map[
				{Append[y,{#}],
					If[#<x,
					Append[y,{#,#+1}],
					{}]}&,Range[x]]],state["pins"]],2],Length[#]>0&]
			]
			],
	
			"nextState"[self_,move_,state_]:>Module[{
				nextPins=state["pins"],
				player=state["toMove"]
			},
			
				If[!MemberQ[self["possibleMoves"[state],move]],
					Print["move not possible"];
				];
				
				nextPins=Insert[nextPins,move[[2,1]]-1,First@move];
				nextPins[[First@move+1]]=nextPins[[First@move+1]]-Last@move[[2]];
				nextPins=ReverseSort[Select[nextPins,#>0&]];
																						
				<|"pins"->nextPins,"toMove"->3-player|>
	
			],
	
			"drawState"[self_,state_]:>Graphics[Text[Style[StringJoin[ToString@state["pins"]," | ",ToString@state["toMove"]],20]],ImageSize->{100,50}]
			],

		"createInstance" :>Function[initialState,kaylesGame["$New"[initialState]]],

		"Alternate names"->{"Given a row of imagined bowling pins, players take turns to knock out either one pin, or two adjacent pins, until all the pins are gone."},
		"Description"->"Kayles",
		"Link"->Hyperlink["https://en.wikipedia.org/wiki/Kayles"]
	|>;
