(* ::Package:: *)

newEntry="nimDef";
nimDef=
	"Nim"->
	<|
		"Name"->{"Nim"},
		"SuperClass"->GameEntity["Combinatorial game"],

		"runTypeDefinition":>
			Class[nimGame ->combinatorialGame,
				"$Properties"->{
				
				"legalStateQ",
				"endStateQWinner",
				"possibleMoves",
				"nextState",
				"drawState"
			},
			
			"$Init"[self_,initialHeaps_]:>(self["initialState"]=<|
				"heaps"->initialHeaps,
				"toMove"->1
			|>;
			self["currentState"]=self["initialState"];),
			
			"initialState"-><||>,
			
			"legalStateQ"[self_]:>Function[state,Module[{},
				If[!AssociationQ[state],
					Print["Game state is not an association"];
				];
				
				If[Keys[state]!={"heaps","toMove"},
					Print["Game state has incorrect keys"];
				];
				
				If[!MemberQ[{1,2},state["toMove"]],
					Print["Player ",state["toMove"], " does not exist"];
				];
				
				If[!ListQ[state["heaps"]],
					Print["Heaps is not a list."];
				];
			]],
	
			"endStateQWinner"[self_,state_]:>Module[{},
				If[state["heaps"]=={},
				<|"endState"->True,"winner"->3-state["toMove"]|>,
				<|"endState"->False,"winner"->Null|>
				]
			],
			
			"possibleMoves"[self_,state_]:>Module[
			{g},
			g=self["endStateQ"[state]];
			If[
				g,
				{},
				Flatten[MapIndexed[Function[{x,y},Map[Append[y,#]&,Range[x]]],state["heaps"]],1]]
			],
	
			"nextState"[self_,move_,state_]:>Module[{
				nextBoard=state["heaps"],
				player=state["toMove"]
			},
			
				If[!MemberQ[self["possibleMoves"[state],move]],
					Print["move not possible"];
				];
				
				nextBoard[[First@move]]-=Last@move;
				If[nextBoard[[First@move]]==0,
					nextBoard=Drop[nextBoard,{First@move}]
				];
																		
				<|"heaps"->nextBoard,"toMove"->3-player|>
	
			],
	
			"drawState"[self_,state_]:>Graphics[Text[Style[StringJoin[ToString@state["heaps"]," | ",ToString@state["toMove"]],14]],ImageSize->{100,50}]			
			],

		"createInstance" :>Function[initialState,nimGame["$New"[initialState]]],

		"Alternate names"->{""},
		"Description"->"Two players take turns removing (or \"nimming\") objects from distinct heaps or piles. On each turn, a player must remove at least one object, and may remove any number of objects provided they all come from the same heap or pile.",
		"Link"->Hyperlink["https://en.wikipedia.org/wiki/Nim"]
	|>;
